local M = {}

local helper = require('scenario/scenariohelper')
local show = true
local reset = true
local i = 0
local gravityCommand = 'obj:setGravity(-9.81)'
local gravity = ''
local primed = ''

local function onScenarioChange(scenario)
	if scenario and scenario.state == 'pre-start' then
		local thePlayer = scenetree.findObject('scenario_player0')
		local gravityCommand = 'obj:setGravity(-9.81)'
		thePlayer:queueLuaCommand(gravityCommand)
		show = true
		reset = true
		gravity = ''
		i = 0
		primed = ''
	end
end

local function checkGravity()
	if gravity == 'jupiter' then
		if show then
			ui_message('Wall opened!', 5, 'A')
			TorqueScript.eval([[
				door1.position = "0 0 0";
			]])
			be:reloadStaticCollision();
			show = false
		end
	else
		ui_message('The box does not have enough weight to move the wall - door primed', 2, 'B')
	end
end

local function onRaceWaypointReached(data)
	if data.vehicleName == 'scenario_player0' then
		if data.waypointName == 'WayPoint1' then
			ui_message('You can change gravity by driving into these areas; gravity = picture shown', 5, 'C')
		end
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'boxTrigger' and data.subjectName == "key_box_1" then
		primed = data.triggerName
		checkGravity()
	elseif data.triggerName == 'jupiter' then
		if gravity == '' then
			gravity = 'jupiter'
			ui_message('Jupiter gravity activated!', 1, 'A')
		end
	elseif data.triggerName == 'moon' then
		if gravity == '' then
			gravity = 'moon'
			ui_message('Moon gravity activated!', 1, 'B')
		end
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "88.9213 205.221 0.346309";
			scenario_player0.rotation = "1 0 0 0";
			door1.position = "79.5354 163.203 -0.184708";
		]])
		be:reloadStaticCollision();
		reset = false
	end
	if gravity ~= '' then
		i = i+dt
		
		if gravity == 'jupiter' then
			if primed ~= '' then
				checkGravity()
			end
			local thePlayer = scenetree.findObject('scenario_player0')
			gravityCommand = 'obj:setGravity(-25)'
			thePlayer:queueLuaCommand(gravityCommand)
		elseif gravity == 'moon' then
			local thePlayer = scenetree.findObject('scenario_player0')
			gravityCommand = 'obj:setGravity(-1.6)'
			thePlayer:queueLuaCommand(gravityCommand)
		end
		if i >= 10 then
			local thePlayer = scenetree.findObject('scenario_player0')
			ui_message('Gravity deactivated', 1, 'D')
			i = 0
			gravity = ''
			gravityCommand = 'obj:setGravity(-9.81)'
			thePlayer:queueLuaCommand(gravityCommand)
		end
		
		local j = 10-i
		if j > 0 and j < 10 then 
			j = math.floor(j*10)/10
			ui_message('Time Left: '..j..'s', 1, 'A')
		end
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
M.onRaceWaypointReached = onRaceWaypointReached
return M