local M = {}

local helper = require('scenario/scenariohelper')
local boolTable = {["show"] = true, ["show2"] = true}
local reset = true
local primed = ''
local i = 0
local gravityCommand = 'obj:setGravity(-9.81)'
local gravity = ''

local function onScenarioChange(scenario)
	if scenario and scenario.state == 'pre-start' then
		local thePlayer = scenetree.findObject('scenario_player0')
		local gravityCommand = 'obj:setGravity(-9.81)'
		thePlayer:queueLuaCommand(gravityCommand)
		boolTable = {["show"] = true, ["show2"] = true}
		gravity = ''
		i = 0
	end
end

local function checkGravity(box)
	if gravity == 'jupiter' then
		if box == 'key_box_3' and boolTable["show"] then
			ui_message('Wall opened!', 5, 'A')
			TorqueScript.eval([[
				door1.position = "0 0 0";
				key_box_3.position = "0 0 0";
			]])
			be:reloadStaticCollision();
			boolTable["show"] = false
		elseif box == 'key_box_2' and boolTable["show2"] then
			helper.flashUiMessage('Wall opened!', 5)
			TorqueScript.eval([[
				door2.position = "0 0 0";
				key_box_2.position = "0 0 0";
			]])
			be:reloadStaticCollision();
			boolTable["show2"] = false
		end
		primed = ''
	else
		ui_message('The box does not have enough weight to move the wall - door primed', 2, 'B')
	end
	if primed ~= '' then
		primed = box
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'wall1' and data.subjectName ~= "scenario_player0" then
		primed = data.triggerName
		checkGravity(data.subjectName)
	elseif data.triggerName == 'wall2' and data.subjectName ~= "scenario_player0" then
		primed = data.triggerName
		checkGravity(data.subjectName)
		
	elseif gravity == '' and data.triggerName == 'jupiter' then
		gravity = 'jupiter'
		ui_message('Jupiter gravity activated!', 1, 'A')
	elseif gravity == '' and data.triggerName == 'moon' then
		gravity = 'moon'
		ui_message('Moon gravity activated!', 1, 'B')
	
	elseif data.triggerName == 'portal1' then
		if gravity == '' then
			ui_message('Teleported!', 1, 'C')
		end
		TorqueScript.eval([[
			scenario_player0.position = "108.327 164.482 0.346309";
		]])
	elseif data.triggerName == 'portal2A' then
		if gravity == '' then
			ui_message('Teleported!', 1, 'D')
		end
		TorqueScript.eval([[
			scenario_player0.position = "171.59 129.292 68.3697";
		]])
	elseif data.triggerName == 'portal2B' then
		if gravity == '' then
			ui_message('Teleported!', 1, 'E')
		end
		TorqueScript.eval([[
			scenario_player0.position = "143.881 125.937 0.346309";
		]])
	elseif data.triggerName == 'portal3' then
		if gravity == '' then
			ui_message('Teleported!', 1, 'F')
		end
		if data.subjectName == 'scenario_player0' then
			TorqueScript.eval([[
				scenario_player0.position = "-8.67849 166.228 0.200859";
			]])
		elseif data.subjectName == 'key_box_2' then
			TorqueScript.eval([[
				key_box_2.position = "-0.67849 166.228 0.200859";
			]])
		end
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "88.9213 205.221 0.346309";
			scenario_player0.rotation = "1 0 0 0";
			key_box_3.position = "147.95 150.049 60.0472";
			key_box_3.rotation = "1 0 0 0";
			key_box_2.position = "-2.17732 130.24 66.817";
			key_box_2.rotation = "1 0 0 0";
			door1.position = "79.5354 163.203 -0.184708";
			door2.position = "33.9984 111.604 -0.184708";
		]])
		be:reloadStaticCollision();
		reset = false
	end
	if gravity ~= '' then
		i = i+dt
		
		if gravity == 'jupiter' then
			if primed ~= '' then
				checkGravity(primed)
			end
			local thePlayer = scenetree.findObject('scenario_player0')
			gravityCommand = 'obj:setGravity(-25)'
			thePlayer:queueLuaCommand(gravityCommand)
		elseif gravity == 'moon' then
			local thePlayer = scenetree.findObject('scenario_player0')
			gravityCommand = 'obj:setGravity(-1.6)'
			thePlayer:queueLuaCommand(gravityCommand)
		end
		if i >= 15 then
			local thePlayer = scenetree.findObject('scenario_player0')
			ui_message('Gravity deactivated', 1, 'A')
			i = 0
			gravity = ''
			gravityCommand = 'obj:setGravity(-9.81)'
			thePlayer:queueLuaCommand(gravityCommand)
		end
		
		local j = 15-i
		if j > 0 and j ~= 15 then 
			j = math.floor(j*10)/10
			ui_message('Time Left: '..j..'s', 1, 'B')
		end
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M