local M = {}

local helper = require('scenario/scenariohelper')
local reset = true
local boxes = 0

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		reset = true
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'portal1A' then
		helper.flashUiMessage('Teleported!', 2)
		if data.subjectName == 'scenario_player0' then
			TorqueScript.eval([[
				scenario_player0.position = "8.02851 40.6891 0.229908";
			]])
		elseif data.subjectName == 'key_box_1' then
			TorqueScript.eval([[
				key_box_1.position = "8.02851 20.6891 0.229908";
			]])
		end
	elseif data.triggerName == 'portal1B' and data.subjectName == 'scenario_player0' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-9.32435 40.6891 0.229908";
		]])
	elseif data.triggerName == 'portal2A' and data.subjectName == 'scenario_player0' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "55.1489 -40.2589 27.3081";
		]])
	elseif data.triggerName == 'portal2B' and data.subjectName == 'scenario_player0' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-76.0702 -39.4125 0.229908";
		]])
	elseif data.triggerName == 'portal3A' and data.subjectName == 'scenario_player0' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-44.1017 -39.87 57.2837";
		]])
	elseif data.triggerName == 'portal3B' and data.subjectName == 'scenario_player0' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "41.3548 -40.0833 57.2431";
		]])
	elseif data.triggerName == 'box' and data.subjectName ~= 'scenario_player0' then
		boxes = boxes+1
		if data.subjectName == 'key_box_1' then
			TorqueScript.eval([[
				key_box_1.position = "10000 0 0";
			]])
		elseif data.subjectName == 'key_box_2' then
			TorqueScript.eval([[
				key_box_2.position = "10000 0 0";
			]])
		end
		if boxes == 2 then
			TorqueScript.eval([[
				number2.position = "10000 0 0";
				number1.position = "63.821 44.2092 2.84335";
			]])
		elseif boxes == 4 then
			TorqueScript.eval([[
				number1.position = "10000 0 0";
				number0.position = "63.821 44.2092 2.84335";
			]])
		end
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "-12.486 -39.9743 0.184686";
			scenario_player0.rotation = "0 0 1 180";
			key_box_1.position = "-19.7106 26.143 6.84536";
			key_box_1.rotation = "0 0 1 180";
			key_box_2.position = "70.4799 28.1026 27.873";
			key_box_2.rotation = "0 0 1 180";
			road1.position = "73.72 -1.22644 -1000";
			number2.position = "63.821 44.2092 2.84335";
			number1.position = "10000 0 0";
			number0.position = "10000 0 0";
		]])
		be:reloadStaticCollision();
		reset = false
	end
	if boxes == 4 then
		helper.flashUiMessage('Road opened!', 3)
		TorqueScript.eval([[
			road1.position = "73.72 -1.22644 35.0097";
		]])
		be:reloadStaticCollision();
		boxes = 5
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M